<div align="center">
<img src="Dokumentation/Misc/LogoRADARplus.jpg" height="150" title="Screenshot Passwortänderung im Probandenmanagementsystem mit Fehlern">
</div>

# RADAR und RADARplus Software

Dieses Repository beinhaltet den Programmcode der im RADAR- und RADARplus-Projekt eingesetzten Software zur Verarbeitung von Gesundheitsdaten aus einem Praxisverwaltungssystem zu Forschungszwecken. Eine detaillierte Beschreibung der Aufgaben und Funktionen der Software ist der [Software Design Specification](Dokumentation/RADAR_Software_Design_Specification.pdf) zu entnehmen. Zu weiteren Unterlagen zum Hintergrund des Projektes kann gerne das Insitut für Medizinische Informatik Göttingen kontaktiert werden.

## Installation und Konfiguration der Software

Voraussetzung für die Installation der RADAR Software ist die Installation von Java JDK Version 8 und Apache Maven. Das Projekt ist ein Standard-Maven-Projekt, siehe dazu die POM des Repositories [pom.xml](pom.xml). 
Da die Software, wie in der Software Design Specification beschrieben, direkt gestartet und unabhängig von einer Installation von einem USB-Stick genutzt wird, gibt es ein Buildskript [prepareUSB.bat](/radar_gui/src/main/resources/prepareUSB.bat), welches automatisch die aktuelle Version deployt, alle nötigen Dateien zusammenkopiert (u.a. die Java Runtime Environment) und in einen Ordner kopiert, dessen Inhalt dann auf einen USB-Stick verschoben wird.

Projektspezifische Anpassungen sind über eine Properties-Datei [RADAR.properties](/radar_gui/src/main/resources/RADAR.properties) vorzunehmen. Ebenso ist ein entsprechendes Zertifikat der Treuhandstelle zu hinterlegen. Zum aktuellen Projektstatus sind alle RADAR-Software-USB-Sticks bereits mit der neusten Version der Software bespielt und im Einsatz. Eine Änderung der Properties-Datei ohne den Sourcecode neu deployen zu müssen ist einfach möglich. Dazu wurde eine Anleitung im Ordner Dokumentation abgelegt: [RADAR Anleitung zur nachträglichen Konfiguration der RADAR-Software.pdf](Dokumentation/RADAR_Anleitung_zur_nachträglichen_Konfiguration_der_RADAR-Software.pdf). 

## Einsatz der Software

Der Ablauf der Bedienung der Software lässt sich über einen [Screencast der RADAR Software](Dokumentation/Misc/AufnahmeRADARSoftware.mp4), (Aufnahmedatum März 2019) leicht nachvollziehen.

Im RADAR Nachfolgeprojekt RADARplus wird alternativ zur papierbasierten Einwilligung die Erfassung der Einwilligung mit Tablets erprobt (Sub-project 3: Paperless, Digital Informed Consent and Signature Management). Anstelle des Übertrags der Einwilligungsinformationen vom Papier in die RADAR-Software wird eine Liste der Einwilligungen über einen Datei-Import in die RADAR-Software übertragen. Das Importverfahren dient als Übergangslösung zur Erprobung. Zu einem späteren Zeitpunkt ist eine automatische Übertragung per Datenschnittstelle angedacht.

Zum Einsatz kommt die Software erneut nach einer ersten Datenerhebung im Jahr 2019 für das Sub-project 1 (RADAR continuation) im Jahr 2022. Die Verarbeitung von FHIR-Ressourcen nach der AWST-Spezifikation anstelle von BDT ist nicht Teil der produktiv eingesetzten Datenerhebung mit der RADAR-Software im RADARplus-Projekt für Sub-project 4 (EPR data acquisition: adaptation to future interfaces).

## Testdatensätze und Schnittstellenbewertung

Teil der Arbeiten an Sub-project 4 war die Erstellung von Testdatensätzen und eine Schnittstellenbewertung der AWST-Schnittstelle. Dazu wurden Testdatensätze in BDT und FHIR erstellt, die im Ordner /Dokumentation/Testdatensatz/ zu finden sind. Ein [Steckbrief des Testdatensatzes BDT](Dokumentation/Steckbrief_Testdatensatz_BDT.pdf) und ein [Steckbrief des Testdatensatzes FHIR](Dokumentation/Steckbrief_Testdatensatz_FHIR.pdf) beschreiben diese Testdaten.

## Referenzen

Siehe [readme.txt](radar_gui/src/main/resources/readme.txt)

## Lizenz

Der RADAR und RADAR plus Quellcode ist lizenziert unter der GNU General Public License 3.0, siehe Lizenz-Datei

## Kontakt

Kontaktieren Sie zur Software das Institut für Medizinische Informatik

RADAR und RADAR Plus als Konsortialprojekt fand unter Beteiligung verschiedener Partner statt:
- Universitätsmedizin Göttingen, Abteilung für Allgemeinmedizin
- Universitätsmedizin Göttingen, Institut für Medizinische Informatik
- Gesellschaft für Wissenschaftliche Datenverarbeitung mbH Göttingen
- Universitätsmedizin Greifswald, Institut für Community Medicine
- Technologie- und Methodenplattform für die vernetzte medizinische Forschung e.V.