package de.uni_goettingen.med.mi.bdtparser.core.bdt_structur.datapackage;

import java.util.LinkedList;

import de.uni_goettingen.med.mi.bdtparser.core.bdt_structur.datacarrier.Datacarrier;

/**
 * This class is used to store a BDT data package.
 * @author Department of Medical Informatics of the University Medical Center Göttingen (Hügel/Pung)
 */
public class Datapackage {
    private LinkedList<Datacarrier> datacarriers;

    /**
     * Constructor for the data package class.
     * Creates an empty list for the data carriers
     */
    public Datapackage() {
        datacarriers = new LinkedList<>();
    }

    /**
     * getter for the Data carrier list
     * @return the data carrier list
     */
    public LinkedList<Datacarrier> getDatacarriers() {
        return datacarriers;
    }

    /**
     * setter for the data carrier list
     * @param datacarriers the new list of data carriers
     */
    public void setDatacarriers(LinkedList<Datacarrier> datacarriers) {
        this.datacarriers = datacarriers;
    }

    /**
     * Returns the number of data carriers in the data package.
     * @return the number of data carriers
     */
    public int size() {
        return datacarriers.size();
    }
}
