package de.uni_goettingen.med.mi.bdtparser.core.bdt_structur.field;

import static de.uni_goettingen.med.mi.bdtparser.core.bdt_structur.field.Datatyp.*;

/**
 * Enum to describes the characteristics of the known fields
 * including the number, minlength, maxlength,data type, rules as intarrayy (could be null)
 * 
 * @author Department of Medical Informatics of the University Medical Center Göttingen (Hügel/Pung)
 */
public enum FieldCharacteristic {
    // Bezeichnungen doppelt vergeben, Satzbezeichnung angefuegt z.B. Strasse -->  Strasse_Praxis
    // feldlaenge var: minlaenge =0, maxlaenge = Integer.Maxvalue

    KBV_Pruefnummer("0101", 7, 7, NUM, new int[]{7}),
    Softwareverantwortlicher("0102", 0, 70, ALNUM, null),
    Software("0103", 0, 70, ALNUM, null),
    Hardware("0104", 0, 70, ALNUM, null),
    Arztnummer("0201", 7, 9, NUM, new int[]{329}),
    Praxistyp("0202", 1, 1, NUM, new int[]{102, 330, 350}),
    Arztname("0203", 0, 70, ALNUM, null),
    ArztgruppeVerbal("0204", 0, 70, ALNUM, null),
    Strasse_Praxis("0205", 0, 70, ALNUM, null),
    PLZOrt("0206", 0, 70, ALNUM, new int[]{-1}),
    ArztMitLeistungskennzeichen("0207", 0, 70, ALNUM, new int[]{15}),
    Telefonnummer("0208", 0, 70, ALNUM, null),
    Telefaxnummer("0209", 0, 70, ALNUM, null),
    Modemnummer("0210", 0, 70, ALNUM, null),
    AnzahlAerzte("0225", 2, 2, NUM, new int[]{350}),
    NameDerErstenFreienKategorieSatzart0010("0250", 0, 70, ALNUM, null),
    InhaltDerErstenFreienKategorieSatzart0010("0251", 0, 70, ALNUM, null),
    NameDerZweitenFreienKategorieSatzart0010("0252", 0, 70, ALNUM, null),
    InhaltDerZweitenFreienKategorieSatzart0010("0253", 0, 70, ALNUM, null),
    NameDerDrittenFreienKategorieSatzart0010("0254", 0, 70, ALNUM, null),
    InhaltDerDrittennFreienKategorieSatzart0010("0255", 0, 70, ALNUM, null),
    NameDerViertenFreienKategorieSatzart0010("0256", 0, 70, ALNUM, null),
    InhaltDerViertenFreienKategorieSatzart0010("0257", 0, 70, ALNUM, null),
    NameDerFuenftenFreienKategorieSatzart0010("0258", 0, 70, ALNUM, null),
    InhaltDerFuenftenFreienKategorieSatzart0010("0259", 0, 70, ALNUM, null),
    NameDerSechstenFreienKategorieSatzart0010("0260", 0, 70, ALNUM, null),
    InhaltDerSechstenFreienKategorieSatzart0010("0261", 0, 70, ALNUM, null),
    NameDerSiebtenFreienKategorieSatzart0010("0262", 0, 70, ALNUM, null),
    InhaltDerSiebtenFreienKategorieSatzart0010("0263", 0, 70, ALNUM, null),
    NameDerAchtenFreienKategorieSatzart0010("0264", 0, 70, ALNUM, null),
    InhaltDerAchtenFreienKategorieSatzart0010("0265", 0, 70, ALNUM, null),
    NameDerNeuntenFreienKategorieSatzart0010("0266", 0, 70, ALNUM, null),
    InhaltDerNeuntenFreienKategorieSatzart0010("0267", 0, 70, ALNUM, null),
    NameDerZehntenFreienKategorieSatzart0010("0268", 0, 70, ALNUM, null),
    InhaltDerZehntenFreienKategorieSatzart0010("0269", 0, 70, ALNUM, null),
    NameDerElftenFreienKategorieSatzart0010("0270", 0, 70, ALNUM, null),
    InhaltDerElftenFreienKategorieSatzart0010("0271", 0, 70, ALNUM, null),
    NameDerZwoefltenFreienKategorieSatzart0010("0272", 0, 70, ALNUM, null),
    InhaltDerZwoelftenFreienKategorieSatzart0010("0273", 0, 70, ALNUM, null),
    NameDerDreizehntenFreienKategorieSatzart0010("0274", 0, 70, ALNUM, null),
    InhaltDerDreizehntenFreienKategorieSatzart0010("0275", 0, 70, ALNUM, null),
    NameDerVierzehntenFreienKategorieSatzart0010("0276", 0, 70, ALNUM, null),
    InhaltDerVierzehntenFreienKategorieSatzart0010("0277", 0, 70, ALNUM, null),
    NameDerFuenfzehntenFreienKategorieSatzart0010("0278", 0, 70, ALNUM, null),
    InhaltDerFuenfzehntenFreienKategorieSatzart0010("0279", 0, 70, ALNUM, null),
    NameDerSechzehntenFreienKategorieSatzart0010("0280", 0, 70, ALNUM, null),
    InhaltDerSechzehntenFreienKategorieSatzart0010("0281", 0, 70, ALNUM, null),
    NameDerSiebtzehntenFreienKategorieSatzart0010("0282", 0, 70, ALNUM, null),
    InhaltDerSiebtzehntenFreienKategorieSatzart0010("0283", 0, 70, ALNUM, null),
    NameDerAchtzehntenFreienKategorieSatzart0010("0284", 0, 70, ALNUM, null),
    InhaltDerAchtzehntenFreienKategorieSatzart0010("0285", 0, 70, ALNUM, null),
    NameDerNeunzehntenFreienKategorieSatzart0010("0286", 0, 70, ALNUM, null),
    InhaltDerNeunzehntenFreienKategorieSatzart0010("0287", 0, 70, ALNUM, null),
    NameDerZwanzigstenFreienKategorieSatzart0010("0288", 0, 70, ALNUM, null),
    InhaltDerZwanzigstenFreienKategorieSatzart0010("0289", 0, 70, ALNUM, null),
    NameDerEinundZwanzigstenFreienKategorieSatzart0010("0290", 0, 70, ALNUM, null),
    InhaltDerEinundZwanzigstenFreienKategorieSatzart0010("0291", 0, 70, ALNUM, null),
    NameDerZweiundZwanzigstenFreienKategorieSatzart0010("0292", 0, 70, ALNUM, null),
    InhaltDerZweinundZwanzigstenFreienKategorieSatzart0010("0293", 0, 70, ALNUM, null),
    NameDerDreiundZwanzigstenFreienKategorieSatzart0010("0294", 0, 70, ALNUM, null),
    InhaltDerDreiundZwanzigstenFreienKategorieSatzart0010("0295", 0, 70, ALNUM, null),
    NameDerVierundZwanzigstenFreienKategorieSatzart0010("0296", 0, 70, ALNUM, null),
    InhaltDerVierundZwanzigstenFreienKategorieSatzart0010("0297", 0, 70, ALNUM, null),
    NameDerFuenfundZwanzigstenFreienKategorieSA0010("0298", 0, 70, ALNUM, null),
    InhaltDerFuenfundZwanzigstenFreienKategorieSA0010("0299", 0, 70, ALNUM, null),
    Patientennummer_Patientenkennung("3000", 0, 10, NUM, null),
    Namenszusatz_VorsatzwortDesPatienten("3100", 0, 15, ALNUM, null),
    NameDesPatienten("3101", 0, 28, ALNUM, null),
    VornameDesPatienten("3102", 0, 28, ALNUM, null),
    GeburtsdatumDesPatienten("3103", 8, 8, DATE, new int[]{20, 304}),
    TitelDesPatienten("3104", 0, 15, ALNUM, null),
    VersichertennummerDesPatienten("3105", 0, 70, ALNUM, new int[]{335}),
    WohnortDesPatienten("3106", 0, 30, ALNUM, new int[]{-1}),
    StrasseDesPatienten("3107", 0, 28, ALNUM, null),
    VersichertenartMFR("3108", 1, 1, NUM, new int[]{116}),
    GeschlechtDesPatienten("3110", 1, 1, NUM, new int[]{112}),
    Arbeitgeber("3150", 0, 70, ALNUM, null),
    BezeichnungDesUnfallversicherungstraegers("3152", 0, 70, ALNUM, null),
    NameDesHauptversicherten("3201", 0, 28, ALNUM, new int[]{338}),
    VornameDesHauptversicherten("3202", 0, 28, ALNUM, new int[]{338}),
    GeburtsdatumDesHauptversicherten("3203", 8, 8, DATE, new int[]{8, 304, 338}),
    WohnortDesHauptversicherten("3204", 0, 30, ALNUM, new int[]{338,-1}),
    StrasseDesHauptversicherten("3205", 0, 28, ALNUM, new int[]{338}),
    TelefonnummerDesVerletzten("3208", 0, 70, ALNUM, null),
    GeschlechtDesHauptversicherten("3210", 1, 1, NUM, new int[]{112}),
    Roentgennummer("3601", 0, 70, ALNUM, null),
    Archivnummer("3602", 0, 70, ALNUM, null),
    BG_Nummer("3603", 0, 70, ALNUM, null),
    PatientSeit("3610", 8, 8, DATE, new int[]{8}),
    VersicherungsbeginnBeiKassenwechsel("3612", 8, 8, DATE, new int[]{8}),
    BerufDesPatienten("3620", 0, 70, ALNUM, null),
    GroesseDesPatienten("3622", 0, 2147483647, FLOAT, null),
    GewichtDesPatienten("3623", 0, 2147483647, FLOAT, null),
    ArbeitgeberDesPatienten("3625", 0, 70, ALNUM, null),
    TelefonnummerPatient("3626", 0, 70, ALNUM, null),
    NationalitaetPatient("3627", 0, 70, ALNUM, null),
    Muttersprache("3628", 0, 70, ALNUM, null),
    ArztnummerHausarzt("3630", 7, 9, NUM, null),
    EntfernungWohnort_Praxis("3631", 0, 70, ALNUM, null),
    InterneZuordnungArztBeiGemeinschaftspraxen("3635", 0, 70, ALNUM, null),
    Rezeptkennung("3637", 1, 1, NUM, null),
    DauerdiagnosenAbDatum("3649", 8, 8, DATE, new int[]{8}),
    Dauerdiagnosen("3650", 0, 70, ALNUM, null),
    DauermedikamenteAbDatum("3651", 8, 8, DATE, new int[]{8}),
    Dauermedikamente("3652", 0, 70, ALNUM, null),
    Risikofaktoren("3654", 0, 70, ALNUM, null),
    Allergien("3656", 0, 70, ALNUM, null),
    Unfaelle("3658", 0, 70, ALNUM, null),
    Operationen("3660", 0, 70, ALNUM, null),
    Anamnese("3662", 0, 70, ALNUM, null),
    AnzahlGeburten("3664", 0, 2147483647, NUM, null),
    AnzahlKinder("3666", 0, 2147483647, NUM, null),
    AnzahlSchwangerschaften("3668", 0, 2147483647, NUM, null),
    Dauertherapie("3670", 0, 70, ALNUM, null),
    Kontrolltermine("3672", 8, 8, DATE, new int[]{8}),
    NameDerErstenFreienKategorieSatzart6100("3700", 0, 70, ALNUM, null),
    InhaltDerErstenFreienKategorieSatzart6100("3701", 0, 70, ALNUM, null),
    NameDerZweitenFreienKategorieSatzart6100("3702", 0, 70, ALNUM, null),
    InhaltDerZweitenFreienKategorieSatzart6100("3703", 0, 70, ALNUM, null),
    NameDerDrittenFreienKategorieSatzart6100("3704", 0, 70, ALNUM, null),
    InhaltDerDrittenFreienKategorieSatzart6100("3705", 0, 70, ALNUM, null),
    NameDerViertenFreienKategorieSatzart6100("3706", 0, 70, ALNUM, null),
    InhaltDerViertenFreienKategorieSatzart6100("3707", 0, 70, ALNUM, null),
    NameDerFuenftenFreienKategorieSatzart6100("3708", 0, 70, ALNUM, null),
    InhaltDerFuenftenFreienKategorieSatzart6100("3709", 0, 70, ALNUM, null),
    NameDerSechstenFreienKategorieSatzart6100("3710", 0, 70, ALNUM, null),
    InhaltDerSechstenFreienKategorieSatzart6100("3711", 0, 70, ALNUM, null),
    NameDerSiebtenFreienKategorieSatzart6100("3712", 0, 70, ALNUM, null),
    InhaltDerSiebtenFreienKategorieSatzart6100("3713", 0, 70, ALNUM, null),
    NameDerAchtenFreienKategorieSatzart6100("3714", 0, 70, ALNUM, null),
    InhaltDerAchtenFreienKategorieSatzart6100("3715", 0, 70, ALNUM, null),
    NameDerNeuntenFreienKategorieSatzart6100("3716", 0, 70, ALNUM, null),
    InhaltDerNeuntenFreienKategorieSatzart6100("3717", 0, 70, ALNUM, null),
    NameDer10LetztenFreienKategorieSA6100("3718", 0, 70, ALNUM, null),
    InhaltDer10LetztenFreienKategorieSA6100("3719", 0, 70, ALNUM, null),
    QuartalDerAbrechnung("4101", 5, 5, NUM, new int[]{16}),
    Ausstellungsdatum("4102", 8, 8, DATE, new int[]{8}),
    Gueltigkeitsdatum("4103", 8, 8, DATE, new int[]{8, 314, 338}),
    KassennummerVKNR("4104", 5, 5, NUM, new int[]{17, 201}),
    Geschaeftsstelle("4105", 0, 70, ALNUM, new int[]{338}),
    Kostentraegeruntergruppe("4106", 2, 2, NUM, new int[]{126}),
    AbrechnungsartSchein("4107", 1, 1, NUM, new int[]{106}),
    LetzterEinlesetagDerVK_KarteImQuartal("4109", 8, 8, DATE, new int[]{8, 335}),
    Bis_DatumDerGueltigkeit("4110", 4, 4, NUM, new int[]{14, 335}),
    KrankenkassennummerIK("4111", 7, 7, NUM, new int[]{18, 335}),
    VersichertenstatusVK("4112", 4, 4, NUM, new int[]{335}),
    Ost_West_StatusVK("4113", 1, 1, NUM, new int[]{117, 335}),
    Gebuehrenordnung("4121", 1, 1, NUM, new int[]{106, 323, 325}),
    Abrechnungsgebiet("4122", 2, 2, NUM, new int[]{119}),
    UrsacheDesLeidens("4201", 1, 1, NUM, new int[]{120}),
    MutmTagDerEntbindung("4206", 8, 8, DATE, new int[]{8}),
    Diagnose_Verdacht("4207", 0, 70, ALNUM, new int[]{322}),
    ErlaeuternderTextZurUeberweisung("4209", 0, 70, ALNUM, new int[]{321}),
    AnkreuzfeldMuvoLSR("4210", 1, 1, NUM, new int[]{101}),
    AnkreuzfeldMuvoHAH("4211", 1, 1, NUM, new int[]{101}),
    AnkreuzfeldAbO_Rh("4212", 1, 1, NUM, new int[]{101}),
    AnkreuzfeldAK("4213", 1, 1, NUM, new int[]{101}),
    UeberweisungVonArztnr("4218", 7, 9, NUM, null),
    UeberweisungAn("4220", 0, 70, ALNUM, null),
    GesetzlAbzugZurStatBehandlungGemaessArtikel6aGOAe("4230", 1, 1, NUM, new int[]{112}),
    StationaereBehandlungVonBis("4233", 16, 16, NUM, new int[]{19}),
    KlasseBeiStatBehandlung("4236", 1, 1, NUM, new int[]{106}),
    Krankenhaus_Name("4237", 0, 70, ALNUM, null),
    Krankenhausaufenthalt("4238", 3, 3, NUM, null),
    Scheinuntergruppe("4239", 2, 2, NUM, new int[]{321, 322, 331, 332, 333, 334}),
    WeiterbehandelnderArzt("4243", 0, 70, ALNUM, null),
    Befund("4267", 0, 70, ALNUM, null),
    Syptome("4268", 0, 70, ALNUM, null),
    Unfalltag("4500", 8, 8, DATE, new int[]{8}),
    UhrzeitDesUnfalls("4501", 4, 4, NUM, new int[]{5}),
    EingetroffenIn("4502", 8, 8, DATE, new int[]{8}),
    UhrzeitDesEintreffens("4503", 4, 4, NUM, new int[]{5}),
    BeginnArbeitszeit("4504", 4, 4, NUM, new int[]{5}),
    Unfallort("4505", 0, 70, ALNUM, null),
    BeschaeftigungAls("4506", 0, 70, ALNUM, null),
    BeschaeftigtSeit("4507", 8, 8, DATE, new int[]{8}),
    Staatsangehoerigkeit("4508", 0, 70, ALNUM, null),
    Unfallbetrieb("4509", 0, 70, ALNUM, null),
    Unfallhergang("4510", 0, 70, ALNUM, null),
    VerhaltenDesVerletztenNachDemUnfall("4512", 0, 70, ALNUM, null),
    ErstmaligeBehandlung("4513", 8, 8, DATE, new int[]{8}),
    BehandlungDurch("4514", 0, 70, ALNUM, null),
    ArtDieserErstenaerztlichenBehandlung("4515", 0, 70, ALNUM, null),
    Alkoholeinfluss("4520", 1, 1, NUM, new int[]{112}),
    AnzeichenDesAlkoholeinflusses("4521", 0, 70, ALNUM, null),
    Blutentnahme("4522", 1, 1, NUM, new int[]{112}),
    Befund_Abrechnung("4530", 0, 70, ALNUM, null),
    Roentgenergebnis("4540", 0, 70, ALNUM, null),
    ArtEtwaigerErstversorgung("4550", 0, 70, ALNUM, null),
    KrankhafteVeraenderungenUnabhaengigVomUnfall("4551", 0, 70, ALNUM, null),
    BedenkenGegenAngaben("4552", 1, 1, NUM, new int[]{112}),
    ArtDerBedenken_Abrechnung("4553", 0, 70, ALNUM, null),
    BedenkenGegenVorliegenEinesArbeitsunfalles("4554", 1, 1, NUM, new int[]{112}),
    ArtDerBedenken("4555", 0, 70, ALNUM, null),
    Arbeitsfaehig("4560", 1, 1, NUM, new int[]{101}),
    WiederArbeitsfaehigAb("4561", 8, 8, DATE, new int[]{8}),
    AU_BescheinigungAusgestellt("4562", 1, 1, NUM, new int[]{101}),
    BesondereHeilbehandlungErforderlich("4570", 1, 1, NUM, new int[]{112}),
    BesondereHeilbehandlungDurch("4571", 1, 1, NUM, new int[]{112}),
    AnschriftDesBehandelndenArztes("4572", 0, 70, ALNUM, null),
    AUAb("4573", 8, 8, DATE, new int[]{8}),
    VoraussichtlicheDauerDerAU("4574", 3, 3, NUM, new int[]{12}),
    Rechnungsart("4580", 2, 2, NUM, null),
    AllgemeineHeilbehandlungDurch("4581", 1, 1, NUM, new int[]{112}),
    AUueber3Tage("4582", 1, 1, NUM, new int[]{101}),
    AUBescheinigtBis("4583", 8, 8, DATE, new int[]{8}),
    NachschauErforderlichAm("4584", 8, 8, DATE, new int[]{8}),
    Rechnungsnummer("4601", 0, 70, ALNUM, null),
    Rechnungsanschrift("4602", 0, 70, ALNUM, null),
    UeberweisenderArzt("4603", 0, 70, ALNUM, null),
    Rechnungsdatum("4604", 8, 8, DATE, new int[]{8}),
    Endsumme("4605", 0, 70, ALNUM, null),
    Abdingungserklaerung("4608", 1, 1, NUM, new int[]{112}),
    UnterkontoArzt("4611", 0, 70, ALNUM, null),
    AnlageZurRechnung("4613", 1, 1, NUM, new int[]{112}),
    Kopfzeile("4615", 0, 70, ALNUM, null),
    Fusszeile("4617", 0, 70, ALNUM, null),
    Leistungstag("5000", 8, 8, DATE, new int[]{8, 304, 324}),
    GNR_GNR_Ident("5001", 1, 7, ALNUM, new int[]{299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    ArtDerUntersuchung("5002", 0, 70, ALNUM, new int[]{299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    EmpfaengerDesBriefes("5003", 0, 70, ALNUM, new int[]{299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    KilometerNurBeiGOAe("5004", 1, 3, NUM, new int[]{325, 299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    Multiplikator("5005", 2, 2, NUM, new int[]{299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    Um_Uhrzeit("5006", 4, 4, NUM, new int[]{5, 299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    Bestellzeit_Ausfuehrungszeit("5007", 8, 8, NUM, new int[]{6, 299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    DKM("5008", 1, 3, NUM, new int[]{299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    FreierBegruendungstext("5009", 0, 70, ALNUM, new int[]{299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    MedikamentAlsBegruendung("5010", 0, 70, ALNUM, new int[]{299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    Sachkosten_Bezeichnung("5011", 0, 70, ALNUM, new int[]{299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    Sachkosten__MaterialkostenDpf("5012", 0, 2147483647, NUM, new int[]{299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    ProzentDerLeistung("5013", 3, 3, NUM, new int[]{299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    Organ("5015", 0, 70, ALNUM, new int[]{299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    BesuchsortBeiHausbesuchen("5017", 0, 70, ALNUM, new int[]{299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    ZoneBeiBesuchen("5018", 2, 2, ALNUM, new int[]{111, 299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    BeschreibungDerGNRBeiPrivatabrechnung("5060", 0, 70, ALNUM, null),
    GebuehrBeiPrivatrechnung("5061", 0, 2147483647, FLOAT, null),
    FaktorBeiPrivatrechnung("5062", 0, 2147483647, FLOAT, null),
    BetragBeiPrivatrechnung("5063", 0, 2147483647, FLOAT, null),
    EndsummePrivatrechnung("5064", 0, 2147483647, FLOAT, null),
    Punktwert("5065", 0, 70, ALNUM, null),
    Honorarbezeichnung("5090", 0, 70, ALNUM, null),
    Gutachten_Bezeichnung("5091", 0, 70, ALNUM, null),
    Abrechnungsdiagnose("6000", 0, 70, ALNUM, new int[]{299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    ICD_Schluessel("6001", 5, 5, ALNUM, new int[]{299}),//added special rule 299,for sentence structure see {@link Validator#check rule} for more
    TagDerSpeicherungVonBehandlungsdaten("6200", 8, 8, DATE, new int[]{8}),
    AktuelleDiagnose("6205", 0, 70, ALNUM, null),
    MedikamentVerordnetAufRezept("6210", 0, 70, ALNUM, null),
    AusserhalbRezeptVerordnetesMedikament("6211", 0, 70, ALNUM, null),
    Aerztemuster("6215", 0, 70, ALNUM, null),
    Befund_Behandlungsdaten("6220", 0, 70, ALNUM, new int[]{-2, -3}),//added special rule -2, see {@link Validator#check rule} for more
    Fremdbefund("6221", 0, 70, ALNUM, new int[]{-2, -3}),//added special rule -2, see {@link Validator#check rule} for more
    Laborbefund("6222", 0, 70, ALNUM, new int[]{-2, -3}),//added special rule -2, see {@link Validator#check rule} for more
    Roentgenbefund("6225", 0, 70, ALNUM, new int[]{-2, -3}),//added special rule -2, see {@link Validator#check rule} for more
    Blutdruck("6230", 0, 70, ALNUM, null),
    Symptome("6240", 0, 70, ALNUM, null),
    Therapie("6260", 0, 70, ALNUM, null),
    PhysikalischeTherapie("6265", 0, 70, ALNUM, null),
    UeberweisungInhalt("6280", 0, 70, ALNUM, null),
    AUDauer("6285", 16, 16, NUM, new int[]{19}),
    AUWegen("6286", 0, 70, ALNUM, null),
    Krankenhauseinweisung_Krankenhaus("6290", 0, 70, ALNUM, null),
    KrankenhauseinweisungWegen("6291", 0, 70, ALNUM, null),
    Bescheinigung_Art("6300", 0, 70, ALNUM, null),
    Bescheinigung_Inhalt("6301", 0, 70, ALNUM, null),
    Attest_Art("6306", 0, 70, ALNUM, null),
    Attest_Inhalt("6307", 0, 70, ALNUM, null),
    NameDesBriefempfaengers("6310", 0, 70, ALNUM, null),
    Anrede("6311", 0, 70, ALNUM, null),
    Strasse_Behandlungsdaten("6312", 0, 70, ALNUM, null),
    PLZ("6313", 0, 70, ALNUM, null),
    Wohnort("6314", 0, 70, ALNUM, null),
    Schlusssatz("6315", 0, 70, ALNUM, null),
    Telefon_Nummer("6316", 0, 70, ALNUM, null),
    Telefax_Nummer("6317", 0, 70, ALNUM, null),
    Arztnummer_Arztident("6319", 0, 70, ALNUM, null),
    Briefinhalt("6320", 0, 70, ALNUM, null),
    Bild_Archivierungssnummer("6325", 0, 70, ALNUM, null),
    Grafikformat("6326", 0, 70, ALNUM, new int[]{298}),//special rule 298 added
    Bildinhalt("6327", 0, 70, ALNUM, new int[]{298}),//special rule 298 added see validator checkrules for more
    NameDerErstenFreienKategorieSatzart6200("6330", 0, 70, ALNUM, null),
    InhaltDerErstenFreienKategorieSatzart6200("6331", 0, 70, ALNUM, null),
    NameDerZweitenFreienKategorieSatzart6200("6332", 0, 70, ALNUM, null),
    InhaltDerZweitenFreienKategorieSatzart6200("6333", 0, 70, ALNUM, null),
    NameDerDrittenFreienKategorieSatzart6200("6334", 0, 70, ALNUM, null),
    InhaltDerDrittenFreienKategorieSatzart6200("6335", 0, 70, ALNUM, null),
    NameDerVierteFreienKategorieSatzart6200("6336", 0, 70, ALNUM, null),
    InhaltDerViertenFreienKategorieSatzart6200("6337", 0, 70, ALNUM, null),
    NameDerFuenftenFreienKategorieSatzart6200("6338", 0, 70, ALNUM, null),
    InhaltDerFuenftenFreienKategorieSatzart6200("6339", 0, 70, ALNUM, null),
    NameDerSechstenFreienKategorieSatzart6200("6340", 0, 70, ALNUM, null),
    InhaltDerSechstenFreienKategorieSatzart6200("6341", 0, 70, ALNUM, null),
    NameDerSiebetenFreienKategorieSatzart6200("6342", 0, 70, ALNUM, null),
    InhaltDerSiebtenFreienKategorieSatzart6200("6343", 0, 70, ALNUM, null),
    NameDerAchtenFreienKategorieSatzart6200("6344", 0, 70, ALNUM, null),
    InhaltDerAchtenFreienKategorieSatzart6200("6345", 0, 70, ALNUM, null),
    NameDerNeuntenFreienKategorieSatzart6200("6346", 0, 70, ALNUM, null),
    InhaltDerNeuntenFreienKategorieSatzart6200("6347", 0, 70, ALNUM, null),
    NameDerZehtenFreienKategorieSatzart6200("6348", 0, 70, ALNUM, null),
    InhaltDerZehntenFreienKategorieSatzart6200("6349", 0, 70, ALNUM, null),
    NameDerElftenFreienKategorieSatzart6200("6350", 0, 70, ALNUM, null),
    InhaltDerElftenFreienKategorieSatzart6200("6351", 0, 70, ALNUM, null),
    NameDerZwoefltenFreienKategorieSatzart6200("6352", 0, 70, ALNUM, null),
    InhaltDerZwoelftenFreienKategorieSatzart6200("6353", 0, 70, ALNUM, null),
    NameDerDreizehntenFreienKategorieSatzart6200("6354", 0, 70, ALNUM, null),
    InhaltDerDreizehntenFreienKategorieSatzart6200("6355", 0, 70, ALNUM, null),
    NameDerVierzehntenFreienKategorieSatzart6200("6356", 0, 70, ALNUM, null),
    InhaltDerVierzehntenFreienKategorieSatzart6200("6357", 0, 70, ALNUM, null),
    NameDerFuenfzehntenFreienKategorieSatzart6200("6358", 0, 70, ALNUM, null),
    InhaltDerFuenfzehntenFreienKategorieSatzart6200("6359", 0, 70, ALNUM, null),
    NameDerSechzehntenFreienKategorieSatzart6200("6360", 0, 70, ALNUM, null),
    InhaltDerSechzehntenFreienKategorieSatzart6200("6361", 0, 70, ALNUM, null),
    NameDerSiebzehntenFreienKategorieSatzart6200("6362", 0, 70, ALNUM, null),
    InhaltDerSiebzehntenFreienKategorieSatzart6200("6363", 0, 70, ALNUM, null),
    NameDerAchtzehntenFreienKategorieSatzart6200("6364", 0, 70, ALNUM, null),
    InhaltDerAchzehntenFreienKategorieSatzart6200("6365", 0, 70, ALNUM, null),
    NameDerNeunzehntenFreienKategorieSatzart6200("6366", 0, 70, ALNUM, null),
    InhaltDerNeunzehntenFreienKategorieSatzart6200("6367", 0, 70, ALNUM, null),
    NameDerZwanzigstenFreienKategorieSatzart6200("6368", 0, 70, ALNUM, null),
    InhaltDerZwanzigstenFreienKategorieSatzart6200("6369", 0, 70, ALNUM, null),
    NameDerEinUndZwanzigstenFreienKategorieSatzart6200("6370", 0, 70, ALNUM, null),
    InhaltDerEinUndZwanzFreienKategorieSatzart6200("6371", 0, 70, ALNUM, null),
    NameDerZweiUndZwanzigstenFreienKategorieSatzart6200("6372", 0, 70, ALNUM, null),
    InhaltDerZweiUndZwanzigstenFreienKategorieSatzart6200("6373", 0, 70, ALNUM, null),
    NameDerDreiUndZwanzigstenFreienKategorieSatzart6200("6374", 0, 70, ALNUM, null),
    InhaltDerDreiUndZwanzigstenFreienKategorieSatzart6200("6375", 0, 70, ALNUM, null),
    NameDerVierUndZwanzigstenFreienKategorieSatzart6200("6376", 0, 70, ALNUM, null),
    InhaltDerVierUndZwanzigstenFreienKategorieSatzart6200("6377", 0, 70, ALNUM, null),
    NameDerFuenfUndZwanzigstenFreienKategorieSatzart6200("6378", 0, 70, ALNUM, null),
    InhaltDerFuenfUndZwanzigstenFreienKategorieSatzart6200("6379", 0, 70, ALNUM, null),
    NameDerSechsUndZwanzigstenFreienKategorieSatzart6200("6380", 0, 70, ALNUM, null),
    InhaltDerSechsUndZwanzigstenFreienKategorieSatzart6200("6381", 0, 70, ALNUM, null),
    NameDerSiebenUndZwanzigstenFreienKategorieSatzart6200("6382", 0, 70, ALNUM, null),
    InhaltDerSiebUndZwanzigstenFreienKategorieSatzart6200("6383", 0, 70, ALNUM, null),
    NameDerAchtUndZwanzigstenFreienKategorieSatzart6200("6384", 0, 70, ALNUM, null),
    InhaltDerAchtUndZwanzigstenFreienKategorieSatzart6200("6385", 0, 70, ALNUM, null),
    NameDerNeunUndZwanzigstenFreienKategorieSatzart6200("6386", 0, 70, ALNUM, null),
    InhaltDerNeunUndZwanzigstenFreienKategorieSatzart6200("6387", 0, 70, ALNUM, null),
    NameDerDreissigstenFreienKategorieSatzart6200("6388", 0, 70, ALNUM, null),
    InhaltDerDreissigstenFreienKategorieSatzart6200("6389", 0, 70, ALNUM, null),
    NameDerEinUndDreissigstenreienKategorieSatzart6200("6390", 0, 70, ALNUM, null),
    InhaltEinUndDreissigstenFreienKategorieSatzart6200("6391", 0, 70, ALNUM, null),
    NameDerZweiUndDreissigstenFreienKategorieSatzart6200("6392", 0, 70, ALNUM, null),
    InhaltDerZweiUndDreissigstenFreienKategorieSatzart6200("6393", 0, 70, ALNUM, null),
    NameDerDreiUndDreissigstenFreienKategorieSatzart6200("6394", 0, 70, ALNUM, null),
    InhaltDerDreiUndDreissigstenFreienKategorieSatzart6200("6395", 0, 70, ALNUM, null),
    NameDerVierUndDreissigstenFreienKategorieSatzart6200("6396", 0, 70, ALNUM, null),
    InhaltDerVierUndDreissigstenFreienKategorieSatzart6200("6397", 0, 70, ALNUM, null),
    NameDerFuenfUndDreissigstenFreienKategorieSA6200("6398", 0, 70, ALNUM, null),
    InhaltDerFuenfUndDreissigstenFreienKategorieSA6200("6399", 0, 70, ALNUM, null),
    Satzidentifikation("8000", 4, 4, NUM, new int[]{167}),
    Satzlaenge("8100", 5, 5, NUM, null),
    Befundart("8401", 1, 1, ALNUM, null),
    GeraeteUndVerfahrensspezKennfeld("8402", 2, 2, ALNUM, null),
    Test_Ident("8410", 6, 6, ALNUM, null),
    Testbezeichnung("8411", 0, 70, ALNUM, null),
    Teststatus("8418", 1, 1, ALNUM, null),
    Ergebnis_Wert("8420", 0, 70, ALNUM, null),
    Einheit("8421", 0, 70, ALNUM, null),
    Grenzwert_Indikator("8422", 0, 2, ALNUM, null),
    Probenmaterial_Nummer("8429", 0, 70, ALNUM, null),
    Probenmaterialbezeichnung("8430", 0, 70, ALNUM, null),
    Material_Spezifikation("8431", 0, 70, ALNUM, null),
    Abnahme_Datum("8432", 8, 8, DATE, new int[]{8}),
    Abnahme_Zeit("8433", 4, 4, NUM, new int[]{5}),
    Keim_Ident("8440", 0, 70, ALNUM, null),
    Keim_Bezeichnung("8441", 0, 70, ALNUM, null),
    Keim_Nummer("8442", 0, 2147483647, NUM, null),
    Resistenz_Methode("8443", 1, 1, NUM, null),
    Wirkstoff_Ident("8444", 0, 70, ALNUM, null), //value in Specification was 8144, possible typo because the number is conflicting with other parts of the spezification
    Wirkstoff_Generic_Name("8445", 0, 70, ALNUM, null),
    MHK_Breakpoint_Wert("8446", 0, 70, ALNUM, null),
    Resistenz_Interpretation("8447", 1, 1, NUM, null),
    Normalwert_Text("8460", 0, 70, ALNUM, null),
    Anmerkung("8470", 0, 70, ALNUM, null),
    Ergebnis_Text("8480", 0, 70, ALNUM, null),
    Abschluss_Zeile("8490", 0, 70, ALNUM, null),
    Signatur("8990", 0, 70, ALNUM, null),
    ArztnummerDesAbsenders("9100", 7, 9, NUM, new int[]{329}),
    DatumDerErstellung("9103", 8, 8, DATE, new int[]{8}),
    OrdnungsnrDatentraegerHeaderDesDP("9105", 3, 3, NUM, null),
    Zeichencode("9106", 1, 1, NUM, new int[]{112}),
    GesamtlaengeDesDatenpaketesInByte("9202", 8, 8, NUM, null),
    AnzahlDatentraegerDesDP("9203", 3, 3, NUM, null),
    VersionADT_Satzbeschreibung("9210", 5, 5, ALNUM, new int[]{118}),
    VersionBDT("9213", 5, 5, ALNUM, new int[]{172}),
    Archivierungsart("9600", 1, 1, NUM, new int[]{106}),
    ZeitraumDerSpeicherung("9601", 16, 16, NUM, new int[]{19}),
    BeginnDerUebertragung("9602", 8, 8, NUM, null),
    SysteminternerParameter("9901", 0, 70, ALNUM, new int[]{999}),
    Debug("4565", 0, 70, ALNUM, null),
	XdtPLZDesPatienten("3112", 0, 10, ALNUM, null),
	XdtOrtDesPatienten("3113", 0, 40, ALNUM, null);

    FieldCharacteristic(String number, int minLength, int laengeMax, Datatyp dt, int rules[]) {
        this.number = number;
        this.minLength = minLength;
        this.maxLength = laengeMax;
        this.type = dt;
        this.rules = rules;

    }

    private Datatyp type;
    private int[] rules;
    private int minLength;
    private int maxLength;
    private final String number;

    /**
     * Returns the fieldnumber as a String
     *
     * @return the fieldnumber
     */
    public String getNumber() {
        return number;
    }

    /**
     * Returns an int array of the length 2, which holds min and max length
     *
     * @return the int array with the length
     */
    public int[] getLaenge() {
        return new int[] { minLength, maxLength };
    }

    /**
     * getter for the MinLength
     *
     * @return
     */
    public int getMinLength() {
        return minLength;
    }

    /**
     * getter for the Maxlenght
     *
     * @return
     */
    public int getMaxLength() {
        return maxLength;
    }

    /**
     * Returns an clone of the int array holding the number of the rules for this field
     *
     * @return the rulenumbers, null if there are no rules for this field
     */
    public int[] getRules() {
        if (rules == null)
            return null;
        return rules.clone();

    }

    /**
     * Return the name of the field, not perfectly identical with the names in the specification
     *
     * @return the name of the field
     */
    public String getName() {
        return super.toString();
    }

    /**
     * Returns the typ of the date that is stored in this field as a String
     *
     * @return the datatyp
     */
    private String typeAsString() {
        return type.name();

    }

    /**
     * Returns the typ of the date that is stored in this field
     *
     * @return the datatyp
     */
    public Datatyp getType() {
        switch (type) {
        case ALNUM:
            return Datatyp.ALNUM;
        case DATE:
            return Datatyp.DATE;
        case NUM:
            return Datatyp.NUM;
        case FLOAT:
            return Datatyp.FLOAT;
        default:
            return null;
        }
    }

    /**
     * Returns the rules as String
     *
     * @return the rules
     */
    private String rulesAsString() {
        if (rules == null)
            return "";
        StringBuilder stringBuilder = new StringBuilder();
        for (int rule : rules) {
            stringBuilder.append(rule);
            stringBuilder.append(' ');
        }
        stringBuilder.deleteCharAt(stringBuilder.length() - 1);
        return stringBuilder.toString();
    }

    /**
     * Overrides the normal to String Method
     *
     * @return the string representing the characteristics from one field
     */
    @Override
    public String toString() {
        StringBuilder stringBuilder = new StringBuilder();
        stringBuilder.append(getName());
        stringBuilder.append(' ');
        stringBuilder.append("minLength: ");
        stringBuilder.append(minLength);
        stringBuilder.append(" maxLength: ");
        stringBuilder.append(maxLength);
        stringBuilder.append(' ');
        stringBuilder.append(typeAsString());
        stringBuilder.append(' ');
        stringBuilder.append(rulesAsString());
        return stringBuilder.toString();
    }

}
