package de.uni_goettingen.med.mi.bdtparser.core.virtualPatientRecord;

import java.util.LinkedList;

import de.uni_goettingen.med.mi.bdtparser.core.bdt_structur.field.Field;

/**
 * Class to store a inability to work and the causes
 * 
 * @author Department of Medical Informatics of the University Medical Center Göttingen (Hügel/Pung)
 */
public class BDTArbeitsunfaehigkeit extends ReferencableReferencer {
    private String auDauer;
    protected LinkedList<BDTValue<String>> auWegen;

    public BDTArbeitsunfaehigkeit(String auDauer, Field reference) {
        super(reference);
        this.auDauer = auDauer;
        auWegen = new LinkedList<>();
    }

    @Override
    public LinkedList<Referenceable> getAsReferenceables() throws IllegalAccessException {
        LinkedList<Referenceable> list = super.getAsReferenceables();
        list.addAll(auWegen);
        return list;
    }

    /**
     * returns the length of the inability to work as String
     * 
     * @return the length
     */
    @Override
    public String getValue() {
        return auDauer;
    }

    /**
     * setter for the length of the inability to work
     */
    @Override
    public void setValue(String value) {
        auDauer = value;
    }

    public LinkedList<BDTValue<String>> getAuWegen() {
        return auWegen;
    }
}
