package de.uni_goettingen.med.mi.bdtparser.core.virtualPatientRecord;

import de.uni_goettingen.med.mi.bdtparser.core.bdt_structur.field.Field;

/**
 *
 * @author Department of Medical Informatics of the University Medical Center Göttingen (Hügel/Pung)
 */
public class BDTBefund extends BDTValue<String> {
    public enum BefundType {
        normal, fremdBefund, laborBefund, roentgenBefund;
    }

    private BefundType type;

    /**
     * Consttructor for the BDT-Befunds.
     * @param value the content of the befund
     * @param Reference the reference to the original BDT-Field
     * @param type the type of the befund
     */
    public BDTBefund(String value, Field Reference, BefundType type) {
        super(value, Reference);
        this.type = type;
    }

    /**
     * Getter for the befund type
     * @return the type
     */
    public BefundType getType() {
        return type;
    }
}
