package de.uni_goettingen.med.mi.bdtparser.core.virtualPatientRecord;

import java.util.LinkedList;

import de.uni_goettingen.med.mi.bdtparser.core.bdt_structur.field.Field;

/**
 * class used to store a permament diagnosis
 * 
 * @author Department of Medical Informatics of the University Medical Center Göttingen (Hügel/Pung)
 */
public class BDTDauerdiagnose extends ReferencableReferencer {
    private String ab;
    protected LinkedList<BDTValue<String>> diagnosen;

    public LinkedList<BDTValue<String>> getDiagnosen() {
        return diagnosen;
    }

    /**
     * constructor
     * 
     * @param ab the start date for the diagnosis
     * @param reference reference to the field
     */
    public BDTDauerdiagnose(String ab, Field reference) {
        super(reference);
        this.ab = ab;
        diagnosen = new LinkedList<>();
    }

    /**
     * Overwrites super methode
     * 
     * @return the list of all referenceable
     * @throws IllegalAccessException never
     */
    public LinkedList<Referenceable> getAsReferenceables() throws IllegalAccessException {
        LinkedList<Referenceable> list = super.getAsReferenceables();
        list.addAll(diagnosen);
        return list;
    }

    /**
     * getter for the start date
     * 
     * @return returns the start date as string
     */
    @Override
    public String getValue() {
        return ab;
    }

    /**
     * setter for the start date
     * 
     * @param value the value
     */
    @Override
    public void setValue(String value) {
        ab = value;

    }
}
