package de.uni_goettingen.med.mi.bdtparser.core.virtualPatientRecord;

import java.util.LinkedList;

import de.uni_goettingen.med.mi.bdtparser.core.bdt_structur.field.Field;

/**
 * Class used to store a permament medicamation
 * 
 * @author Department of Medical Informatics of the University Medical Center Göttingen (Hügel/Pung)
 */
public class BDTDauermedikamentation extends ReferencableReferencer {
    private String ab;
    protected LinkedList<BDTValue<String>> medikamente;

    public LinkedList<BDTValue<String>> getMedikamente() {
        return medikamente;
    }

    public BDTDauermedikamentation(String ab, Field reference) {
        super(reference);
        this.ab = ab;
        medikamente = new LinkedList<>();
    }

    @Override
    public LinkedList<Referenceable> getAsReferenceables() throws IllegalAccessException {
        LinkedList<Referenceable> list = super.getAsReferenceables();
        list.addAll(medikamente);
        return list;
    }

    @Override
    public String getValue() {
        return ab;
    }

    @Override
    public void setValue(String value) {
        ab = value;

    }
}
