package de.uni_goettingen.med.mi.bdtparser.core.virtualPatientRecord;

import java.util.LinkedList;

import de.uni_goettingen.med.mi.bdtparser.core.bdt_structur.field.Field;

/**
 * class used to store a gebuehrenummern
 * 
 * @author Department of Medical Informatics of the University Medical Center Göttingen (Hügel/Pung)
 */
public class BDTGNR extends ReferencableReferencer {
    private String gebuehrennummer;

    public BDTGNR(String gebuehrennummer, Field reference) {
        super(reference);
        this.gebuehrennummer = gebuehrennummer;
    }

    private void setGebuehrennummer(String gebuehrennummer) {
        this.gebuehrennummer = gebuehrennummer;
    }

    @Override
    public LinkedList<Field> getReferences() {
        return references;
    }

    @Override
    public String getValue() {
        return gebuehrennummer;
    }

    @Override
    public void setValue(String value) {
        setGebuehrennummer(value);
    }
}
