package de.uni_goettingen.med.mi.bdtparser.core.virtualPatientRecord;

import java.util.LinkedList;

import de.uni_goettingen.med.mi.bdtparser.core.bdt_structur.field.Field;

/**
 * Class used to store a transferal to a hospital
 * 
 * @author Department of Medical Informatics of the University Medical Center Göttingen (Hügel/Pung)
 */
public class BDTKrankenhausEinweisung extends ReferencableReferencer {
    private String krankenhaus;
    protected LinkedList<BDTValue<String>> einweisungWegen;

    /**
     * constructor
     * 
     * @param krankenhaus the hospital the patient got send
     * @param reference the reference to a field
     */
    public BDTKrankenhausEinweisung(String krankenhaus, Field reference) {
        super(reference);
        this.krankenhaus = krankenhaus;
        einweisungWegen = new LinkedList<>();
    }

    public LinkedList<Referenceable> getAsReferenceables() throws IllegalAccessException {
        LinkedList<Referenceable> list = new LinkedList<Referenceable>();
        list.add(this);
        list.addAll(einweisungWegen);
        return list;
    }

    @Override
    public String getValue() {
        return krankenhaus;
    }

    @Override
    public void setValue(String value) {
        krankenhaus = value;

    }

    public void addEinweisungsGrund(BDTValue reason) {
        einweisungWegen.add(reason);
    }

    public LinkedList<BDTValue<String>> getEinweisungWegen() {
        return einweisungWegen;
    }

    public void setEinweisungWegen(LinkedList<BDTValue<String>> einweisungWegen) {
        this.einweisungWegen = einweisungWegen;
    }
}
