package de.uni_goettingen.med.mi.bdtparser;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertTrue;

import java.util.concurrent.LinkedTransferQueue;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.junit.Before;
import org.junit.Ignore;

import de.uni_goettingen.med.mi.bdtparser.core.io.reader.BdtFileReader;

/**
 * JUnit test for the BdtFileReader
 * 
 * @author Jonas Hügel Created by huegel_jonas on 02.05.2017.
 */
public class BdtFileReaderTest {
	private final static Logger logger = LogManager.getLogger(BdtFileReaderTest.class);
	private BdtFileReader bdtFileReader;
	private LinkedTransferQueue<String> testqueue;
	private int lines;// number of lines of files

	@Before
	public void setUp() throws Exception {
		testqueue = new LinkedTransferQueue<String>();
		bdtFileReader = new BdtFileReader(testqueue, "src\\test\\ressources\\bdtFiles");
		lines = 78;
	}

	@Ignore("not ready yet")
	public void testApp() {
		Thread reader = new Thread(bdtFileReader);
		reader.run();
		try {
			reader.join();
		} catch (InterruptedException e) {
			logger.error("Interrupt while waiting for reader to finish");
		}
		assertEquals("Testing queuesize == number of lines", lines, testqueue.size());
		for (int i = 0; i < testqueue.size(); i++) {
			String line = testqueue.poll();
			testLine(line, i);
		}

	}

	// testen auf richtige Lange
	// Sonderzeichen, richtige Coidierung
	@Ignore("not ready yet")
	private void testLine(String line, int i) {
		assertNotNull(line);
		switch (i) {
		case 0:
			assertEquals(11, line.length());
			break;
		case 1:
			assertEquals(12, line.length());
			break;
		case 2:
			assertEquals(15, line.length());
			break;
		case 3:
			assertEquals(15, line.length());
			break;
		case 4:
			// assertEquals(10,line.length());
			break;
		case 37:
			assertEquals(8, line.length());
			assertEquals("1", line.substring(7));// encoding
			break;
		case 6:
			assertEquals(11, line.length());
			break;
		case 49:
			assertEquals("Testting mutated vowels", "ÄäÖöÜüß SW-Verantwortlicher", line.substring(7));
			// System.out.println(line.substring(7) +" ÄäÖöÜüß SW-Verantwortlicher");
			break;
		default:
			assertTrue(line.length() > 7);
		}
	}

}
