package de.uni_goettingen.med.mi.radar_software.model;

import java.util.List;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * Wrapper class for informedConsentList. The list of informed consents
 * is stored in an xml-file.
 * 
 * @author Department of Medical Informatics of the University Medical Center Göttingen (Hügel/Pung)
 */
@XmlRootElement(name = "informedConsentList")
public class InformedConsentWrapper {

    private List<InformedConsent> lstInformedConsent;

    /**
     * Method to get the List of the patient consent
     * @return
     */
    @XmlElement(name = "informedConsent")
    public List<InformedConsent> getInformedConsent() {
        return lstInformedConsent;
    }

    /**
     * Setter to set the list of informed consent
     * @param lstInformedConsent
     */
    public void setInformedConsent(List<InformedConsent> lstInformedConsent) {
        this.lstInformedConsent = lstInformedConsent;
    }

}