package de.uni_goettingen.med.mi.radar_software.ths.message;

import java.io.IOException;
import java.io.InputStreamReader;

import javax.net.ssl.HttpsURLConnection;

import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;

/**
 * THS AbstractResponse
 * 
 * Code friendly adopted from DZHK colleagues (author Rottmann)
 * 
 * @author Department of Medical Informatics of the University Medical Center Göttingen (Hügel/Pung)
 */
public abstract class AbstractResponse {

    JSONObject response;

    AbstractResponse(HttpsURLConnection request) throws IOException, ParseException {
        InputStreamReader in = new InputStreamReader(request.getInputStream(),"UTF-8");
        this.response = (JSONObject) (new JSONParser()).parse(in);
        in.close();
    }

    @Override
    public String toString() {
        return this.response.toJSONString();
    }

}