package de.uni_goettingen.med.mi.radar_software.ths.message;

import java.io.IOException;

import javax.net.ssl.HttpsURLConnection;

import org.json.simple.parser.ParseException;

/**
 * THS GetSessionResponse
 * 
 * Code friendly adopted from DZHK colleagues (author Rottmann)
 * 
 * @author Department of Medical Informatics of the University Medical Center Göttingen (Hügel/Pung)
 */
public class GetSessionResponse extends AbstractResponse {

    GetSessionResponse(HttpsURLConnection request) throws IOException, ParseException {
        super(request);
    }

    String getSessionId() {
        return (String) this.response.get("sessionId");
    }

    String getUri() {
        String uri = (String) this.response.get("uri");
        // uri = uri.replaceAll("https://test.radar", "https://basic.test.radar"); // redirect
        return uri;
    }

}