package de.uni_goettingen.med.mi.radar_software.ths.message;

import java.io.IOException;

import javax.net.ssl.HttpsURLConnection;

import org.json.simple.JSONObject;
import org.json.simple.parser.ParseException;

/**
 * THS GetTokenResponse
 * 
 * Code friendly adopted from DZHK colleagues (author Rottmann)
 * 
 * @author Department of Medical Informatics of the University Medical Center Göttingen (Hügel/Pung)
 */
public class GetTokenResponse extends AbstractResponse {

    GetTokenResponse(HttpsURLConnection request) throws IOException, ParseException {
        super(request);
    }

    public String getMethod() {
        JSONObject call = (JSONObject) this.response.get("call");
        JSONObject action = (JSONObject) call.get("action");

        return (String) action.get("method");
    }

    public String getUrl() {
        JSONObject call = (JSONObject) this.response.get("call");
        JSONObject action = (JSONObject) call.get("action");

        return (String) action.get("url");
    }

    public String getTokenId() {
        return (String) this.response.get("tokenId");
    }

    public String getUri() {
        return (String) this.response.get("uri");
    }

}