package de.uni_goettingen.med.mi.radar_software.util;

/**
 *
 * @author Department of Medical Informatics of the University Medical Center Göttingen (Hügel/Pung)
 */
public class RuleErrorEntry {
    public static final String DESCRIPTION = "Violated Rules:";
    private String fieldNumber;
    private int ruleNumber;

    public RuleErrorEntry(String fieldNumber, int ruleNumber) {
        this.fieldNumber = fieldNumber;
        this.ruleNumber = ruleNumber;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o)
            return true;
        if (o == null || getClass() != o.getClass())
            return false;

        RuleErrorEntry entry = (RuleErrorEntry) o;

        if (ruleNumber != entry.ruleNumber)
            return false;
        return fieldNumber.equals(entry.fieldNumber);
    }

    @Override
    public int hashCode() {
        int result = fieldNumber.hashCode();
        result = 31 * result + ruleNumber;
        return result;
    }

    public int getRuleNumber() {
        return ruleNumber;
    }

    public void setRuleNumber(int ruleNumber) {
        this.ruleNumber = ruleNumber;
    }

    public String getFieldNumber() {
        return fieldNumber;
    }

    public void setFieldNumber(String fieldNumber) {
        this.fieldNumber = fieldNumber;
    }
}
