package de.uni_goettingen.med.mi.radar_software.util;

import java.util.List;

/**
 *
 * @author Department of Medical Informatics of the University Medical Center Göttingen (Hügel/Pung)
 */
public class SentenceStructureErrorEntry {
    String sentenceNumber;
    String fieldNumber;
    List<String> expectedFieldNumbers;

    public SentenceStructureErrorEntry(String fieldNumber, String sentenceNumber, List<String> expectedFieldNumbers) {
        this.sentenceNumber = sentenceNumber;
        this.fieldNumber = fieldNumber;
        this.expectedFieldNumbers = expectedFieldNumbers;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null)
            return false;
        if (!(obj instanceof SentenceStructureErrorEntry))
            return false;
        SentenceStructureErrorEntry other = (SentenceStructureErrorEntry) obj;
        return (this.fieldNumber.equals(other.fieldNumber) && this.sentenceNumber.equals(other.sentenceNumber) && this.expectedFieldNumbers.equals(other.expectedFieldNumbers));
    }

    @Override
    public int hashCode() {
        int result = sentenceNumber != null ? sentenceNumber.hashCode() : 0;
        result = 31 * result + (fieldNumber != null ? fieldNumber.hashCode() : 0);
        result = 31 * result + (expectedFieldNumbers != null ? expectedFieldNumbers.hashCode() : 0);
        return result;
    }
}
