package de.uni_goettingen.med.mi.radar_software.view;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import de.uni_goettingen.med.mi.radar_software.MainApp;
import javafx.application.HostServices;
import javafx.fxml.FXML;
import javafx.scene.control.Hyperlink;

/**
 * The controller for the welcome view. A few introductory texts are displayed, no functionality.
 *
 * @author Department of Medical Informatics of the University Medical Center Göttingen (Hügel/Pung)
 */
public class WelcomeController implements WizardController {

    private static final Logger log = LogManager.getLogger(WelcomeController.class);
    private MainApp mainApp;
    private HostServices hostServices;
    public Hyperlink dfgGeprisHyperlink;

    @FXML
    private void initialize() {
        log.debug("initialized");
    }

    @Override
    public void setMainApp(MainApp mainApp) {
        this.mainApp = mainApp;
        log.debug("got " + this.mainApp);
    }

    public HostServices getHostServices() {
        return hostServices;
    }

    public void setHostServices(HostServices hostServices) {
        this.hostServices = hostServices;
    }

    @FXML
    private void openURL() {
        if (hostServices != null) {
            hostServices.showDocument(dfgGeprisHyperlink.getText());
        }
    }

}